from fastapi import APIRouter, Form, HTTPException
from starlette.requests import Request
from starlette.responses import HTMLResponse
from starlette.templating import Jinja2Templates

from src.core.ydl import VideoDownloader
from src.exceptions.download_exceptions import SiteNotImplementedException

main_router = APIRouter()


templates = Jinja2Templates(directory="templates")


@main_router.get("/", response_class=HTMLResponse)
async def index(request: Request):
    return templates.TemplateResponse("index.html", {"request": request})


@main_router.post('/submit')
def disable_cat(request: Request, link: str = Form(...)):
    downloader = VideoDownloader(link=link, ydl_opts={
                "forceurl": True,
                "username": "garick.badalov@yandex.ru",
                "password": "garik876.",
            })
    try:
        result = downloader.download()
    except SiteNotImplementedException as ex:
        raise HTTPException(
            status_code=400,
            detail=ex.message
        )
    return templates.TemplateResponse("index.html", {"request": request, "result": result["url"]})
